// ------------------------------------------------------------------
//                                              Save Screenshot.mq4
//                                          Copyright  2009, FxORG
//                                             http://www.fxorg.org
//
// Creates a gif file from the chart which is active when the script
// is executed. Filenaming, size and location can be customized with
// several parmeters.
//
// ------------------------------------------------------------------
// V1.0 - Initial Release
// ------------------------------------------------------------------

#property copyright "Copyright  2009, FxORG"
#property link      "http://www.fxorg.org"

// Uncomment this line if you want to be asked each execution
//#property show_inputs

#import "utility.dll"
void MoveFile(string src, string dest);
void CreateDirectory(string dir);
string GetInstallDir();

// Set to true if the filename should be prefixed with the account name
// Note that if you upload screenshots you should avoid displaying this to others
extern bool IncludeAccountName = false;
// Set to true if the filename should be prefixed with the account number
// Note that if you upload screenshots you should avoid displaying this to others
extern bool IncludeAccountNumber = false;
// Set to true if the screenshots are sorted into subdirectories with the symbol name
extern bool SymbolDirectory = true;
// Select one or more character(s) which to use to separate the components of the filename
extern string Separator = "-";
// Adjust this path to the destination where you want the screenshots copied to. The folder
// will be created if it does not exist. If this directory is blank the screenshots will be
// left in the \experts\files folder.
extern string TargetDir = "C:\\Documents and Settings\\USER\\My Documents\\Trades\\";
// Width of the image in pixels
extern int Width = 1024;
// Height of the image in pixels
extern int Height = 768;


// ---------------------------------------------------------------------------------------------
// Function start()
// ---------------------------------------------------------------------------------------------

int start()
{
   string fileName;
   
   if (IncludeAccountName)
   {
      fileName = fileName + AccountName() + Separator;
   }
   
   if (IncludeAccountNumber)
   {
      fileName = fileName + AccountNumber() + Separator;
   }
   
   fileName = fileName + Symbol() + "-" + Year();
   
   if (Month() < 10)
      fileName = fileName + Separator + "0" + Month();
   else
      fileName = fileName + Separator + Month();
   
   if (Day() < 10)
      fileName = fileName + Separator + "0" + Day();
   else
      fileName = fileName + Separator + Day();
   
   if (Hour() < 10)
      fileName = fileName + Separator + "0" + Hour();
   else
      fileName = fileName + Separator + Hour();
   
   if (Minute() < 10)
      fileName = fileName + Separator + "0" + Minute();
   else
      fileName = fileName + Separator + Minute();
   
   if (Seconds() < 10)
      fileName = fileName + Separator + "0" + Seconds();
   else
      fileName = fileName + Separator + Seconds();
   
   fileName = fileName + ".gif";
   
   WindowScreenShot(fileName, Width, Height);
   
   if (StringLen(TargetDir) > 0)
   {
      string src = GetInstallDir() + "\\experts\\files\\" + fileName;
      string dst = TargetDir;
      
      if (SymbolDirectory)
      {
         dst = dst + Symbol() + "\\";
      }
      
      CreateDirectory(dst);
      MoveFile(src, dst + fileName);
   }
}


